Description

Facter 2 is at RC1, and while it has no structered facts by default, it will have in the future, and people will start writing their own

probably even sooner.

I quickly looked into this using the foreman_chef plugin. I came up with this:

1. Add 'plainify' and 'get_key' to node.rb from chef_foreman_handler, and change 'build_body' to call:

{'facts' => plainify(puppet_facts['values'].merge({:_type => 'foreman_chef'})).flatten.inject(&:me

rge), 'name' => hostname, 'certname' => certname}

 2. Add foreman_chef plugin to Foreman

3. Fix https://github.com/theforeman/foreman/blob/develop/app/services/fact_importer.rb#L79 to not drop Integers

4. (optional) Handle changes of fact type. Currently if you upload "foo: bar" and then upload "foo: { "bar" => "quux" }" it won't display

properly due to the old string-type fact in the db.

We'll probably want to move the hash-handling code out of foreman_chef and into core. I'd also consider investigating the way we

compress and uncompress the facts hash with '::' vs just sending/parsing the whole hash directly.

Related issues:

Related to Foreman - Feature #2293: Support structured facts Duplicate 03/08/2013

Related to Foreman - Feature #3339: Support for nested facts and specialised ... Closed 10/17/2013

Related to Foreman - Feature #7525: Report volume sizes via facter Closed 09/18/2014

Related to Discovery - Feature #3860: Implement fully automated provisioning Closed 12/12/2013

Related to Foreman - Tracker #8447: Puppet 4 support Closed 11/19/2014

Related to Foreman - Feature #15522: Support for array/multi-valued facts New 06/27/2016

Related to Salt - Refactor #15591: Use new structured facts parser New 07/06/2016

Related to Foreman - Bug #16576: Structured facts importer is extremely slow Closed 09/15/2016

Has duplicate Foreman - Bug #6414: structured facts not displayed in foreman Duplicate 06/27/2014

Has duplicate Foreman - Feature #12703: Layout aggregated fact value display ... Duplicate 12/04/2015

Associated revisions

Revision c696f740 - 07/06/2016 11:07 AM - Dominic Cleal

fixes #4528 - import structured Puppet facts

A new structured fact importer converts nested hashes into the

FactName::SEPARATOR layout used for internal structured fact storage and

extends the regular fact importer to create the hierarchy of FactNames.

This can be used by other plugins requiring structured storage. It does

not support storage of arrays beyond current conversion to strings.

History

#1 - 03/03/2014 03:59 PM - Dominic Cleal
https://github.com/theforeman/foreman/blob/develop/app/services/fact_importer.rb#L79


- Subject changed from Support structured facts to Support Facter 2 structured facts

#2 - 03/03/2014 03:59 PM - Dominic Cleal

- Related to Feature #2293: Support structured facts added

#3 - 03/03/2014 04:00 PM - Dominic Cleal

- Related to Feature #3339: Support for nested facts and specialised plugins added

#4 - 03/03/2014 04:01 PM - Greg Sutcliffe

- Description updated

#5 - 06/27/2014 10:12 AM - Dominic Cleal

- Has duplicate Bug #6414: structured facts not displayed in foreman added

#6 - 08/17/2014 11:42 AM - Stephen Benjamin

ForemanChef's code "just works" for Salt's structured facts as well (after plainifying).  It would be awesome to have a nested fact importer in Core that

could just take the hash.

#7 - 08/18/2014 03:02 AM - Marek Hulán

Let's merge it into core :-) Note that facts should still be scoped by name so we should add ForemanSalt::FactImporter inheriting from

ForemanChef::FactImporter or ideally extract the generic part to some new NestedFactImporter class and let inherit both from it. Important methods

that would remain importer specific: fact_name_class and support_background. Importer from ForemanChef is also lacking tests at the moment so it

should be covered first.

#8 - 08/21/2014 05:48 AM - Stephen Benjamin

- Bugzilla link set to 1132402

#9 - 10/13/2014 11:14 AM - Lukas Zapletal

- Related to Feature #7525: Report volume sizes via facter added

#10 - 10/13/2014 11:17 AM - Lukas Zapletal

Guys I need to get some integers in (discovery, hard disk volume sizes), can I post a patch to simply convert the number to string? See the

referenced issue.

#11 - 10/14/2014 07:15 AM - Lukas Zapletal

For the record, I filed a PR to convert non-string values to strings so it prevents from failure. We might want to do something smarter than this in this

ticket, but since Staypuft is blocked by this I propose this solution: https://github.com/theforeman/foreman_discovery/pull/90

#12 - 11/19/2014 03:20 AM - Lukas Zapletal

- Related to Feature #3860: Implement fully automated provisioning added

#13 - 11/19/2014 03:21 AM - Lukas Zapletal

Bumping up the priority a bit, if this is implemented, our Discovery rule engine is much more powerful.

#14 - 11/25/2014 06:44 PM - Joshua Hoblitt

I just smacked into this in 1.6.3.  Not even string structured facts are queryable via the gui.

#15 - 06/09/2015 10:03 AM - Jeff Sparrow

This has been open for sometime and puppet has really pushed to using structured data facts more often, within their future parser it makes things

much easier.  Hope this is included very soon as hashes and arrays are fairly common and should be supported

#16 - 08/07/2015 10:18 AM - Sven Milinski

Hello,

can anyone tell me when Foreman is able to manage facter 2 array/hash values ?

Is it on the roadmap ?

Would be nice if someone can update this issue

Thanks
https://github.com/theforeman/foreman_discovery/pull/90


#17 - 08/27/2015 10:05 AM - Jeff Sparrow

Any update?  Not having structured facts in foreman is getting to be a big hassle to get around.  Would be nice to get an update, its been almost a

year.  Thanks.

#18 - 12/07/2015 03:34 AM - Dominic Cleal

- Has duplicate Feature #12703: Layout aggregated fact value display format added

#19 - 03/15/2016 07:42 PM - Anonymous

- Related to Tracker #8447: Puppet 4 support added

#20 - 05/23/2016 03:53 AM - Maxim Burgerhout

Doesn't the foreman_ansible implementation by @dLobatog have nice structured facts already? It might be possible to use that same code?

#21 - 06/03/2016 04:41 PM - Daniel Lobato Garcia

Yup - it's also partly taken from Salt so hopefully we can provide this from core to all plugins.

#22 - 06/24/2016 07:32 AM - Dominic Cleal

- Status changed from New to Assigned

- Assignee set to Dominic Cleal

#23 - 06/27/2016 05:27 AM - Dominic Cleal

- Related to Feature #15522: Support for array/multi-valued facts added

#24 - 06/27/2016 05:35 AM - Dominic Cleal

Tickets relating to handling of non-structured, non-string facts (ints, bools) which are mentioned above:

#7525 changed the importer to handle non-string facts by converting their values to strings, this helps notably with integer facts.

#11150 changed fact searching to support integer comparisons, since Foreman stores integers as strings internally.

I don't propose changing the storage of non-string facts in Foreman, it's sufficient to store them as strings and convert them when used (e.g.

when searching).

Tickets relating to handling of array values:

#15522 filed to enable storage of multiple fact values for arrays, instead of storing them as a string (e.g. ["a", "b"])

Tickets relating to handling of structured/nested/hash facts:

#3339 added support for structured facts - that is, facts whose value is a hash of more facts

This ticket will be used only to update the Puppet fact importer to store structured facts/hashes of facts.

#25 - 06/27/2016 06:19 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3613 added

#26 - 07/06/2016 11:13 AM - Stephen Benjamin

- Related to Refactor #15591: Use new structured facts parser added

#27 - 07/06/2016 12:01 PM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset c696f740e9b8551e0acbf9db9ec390294ee71560.

#28 - 07/08/2016 06:39 AM - Dominic Cleal

- translation missing: en.field_release set to 160

#29 - 09/16/2016 03:32 AM - Dominic Cleal

- Related to Bug #16576: Structured facts importer is extremely slow added
